package siva;

import java.util.ArrayList;
import org.w3c.dom.Node;

public class MacroInfo {
    String id;
    public ArrayList<TestExistenceInfo> test;
    public ArrayList<FormatInfo> format;

    MacroInfo (String id, ArrayList<FormatInfo> format, ArrayList<TestExistenceInfo> test) {
        this.id = id;
        this.format = format;
        this.test = test;
    }

    String execute(PathInfo pi, Style style, Node node, String context) {
        StringBuilder sb = new StringBuilder();
        if (test != null) {
            for (TestExistenceInfo ti : test) {
                if (!ti.satisfiesConstraint(context)) {
                    return "";
                }
            }
        }

        return FormatInfo.format(pi, style, format, node, context);
    }
}
