package siva;

import java.util.ArrayList;
import org.sanskritlibrary.Regex;
import org.sanskritlibrary.StackEntry;
import org.sanskritlibrary.XML;
import org.w3c.dom.Node;

public class MarkupInfo {
    public static int objectCount = 1;
    public Path path;
    public Regex re;
    public ArrayList<FormatInfo> format;
    public ArrayList<FormatInfo> before;
    public ArrayList<FormatInfo> after;
    public String style;
    public Style _style;
    public int lineNumber;      // for debugging
    public int debugging;

    public MarkupInfo (String path, ArrayList<FormatInfo> format, ArrayList<FormatInfo> before,
            ArrayList<FormatInfo> after, Style style, int lineNumber) {
        this.path = new Path(path);
        this.format = format;
        this.before = before;
        this.after = after;
        this._style = style;
        if (style != null) {
            this.style = style.name();
        } else {
            this.style = Style.ANY.name();
        }
        this.lineNumber = lineNumber;
        this.debugging = objectCount++;
    }

    public String getKey () {
        return String.format("%s/%s", path.getKey(), style);
    }


    public String format(PathInfo pi, Style style, Node node, ArrayList<FormatInfo> fis, String context) {
        return FormatInfo.format(pi, style, fis, node, context);
    }
}
