package siva;

import org.sanskritlibrary.Regex;

public class Path {
    static Regex reAttribute = new Regex("", "(.*?)\\s*\\[\\s*(.*?)\\s*=\\s*(.*?)\\s*\\]");
    Regex re;
    String path;
    String attributeName;
    String attributeValue;

    Path (String path) {
        boolean isRegex = path.charAt(0) == '/';
        this.path = path;
        reAttribute.reset(path);
        if (reAttribute.find()) {
            this.path = reAttribute.getGroup(1);
            if (isRegex) {
                this.path += "$/";
            }
            attributeName = reAttribute.getGroup(2);
            attributeValue = reAttribute.getGroup(3);
            if (attributeValue.charAt(0) == '\'') {
                attributeValue = attributeValue.substring(1, attributeValue.length()-1);
            }
        }
        if (isRegex) {
            re = new Regex("", this.path.substring(1, this.path.length()-1));
        }
    }


    String getKey () {
        StringBuilder sb = new StringBuilder();
        if (path != null) {
            if (attributeName == null) {
                return path;
            } else {
                return String.format("%s/%s/%s", path, attributeName, attributeValue);
            }
        } else {
            return re.getPattern();
        }
    }
    

    boolean compare (String context) {
        if (re == null) {
            return path.equals(context);
        } else {
            re.reset(context);
            return re.find();
        }
    }

    @Override
    public String toString () {
        return path;
    }
}
