package siva;

import org.sanskritlibrary.XML;
import org.w3c.dom.Node;

public class TestValueInfo {

    boolean isExistenceTest;
    boolean exists;
    boolean isAttribute;
    String name;
    String value;

    TestValueInfo(String test) {
        if (test.contains("=")) {
            String[] fields = test.split("=");
            isAttribute = fields[0].charAt(0) == '@';
            name = fields[0];
            if (isAttribute) {
                name = name.substring(1);
            }
            value = fields[1];
        } else if (test.charAt(0) == '!') {
            isExistenceTest = true;
            exists = false;
            test = test.substring(1);
            if (test.charAt(0) == '@') {
                isAttribute = true;
                test = test.substring(1);
            }
            this.name = test;
        } else {
            exists = true;
            if (test.charAt(0) == '@') {
                isAttribute = true;
                test = test.substring(1);
            }
            this.name = test;
        }
    }

    boolean evaluate(Node node) {
        boolean rc = false;
        if (isExistenceTest) {
            if (isAttribute) {
                boolean status = node.getAttributes().getNamedItem("name") == null;
                rc = exists == status;
            }
        } else {
            if (isAttribute) {
                Node att = node.getAttributes().getNamedItem(name);
                if (att == null) {
                    rc = false;
                } else {
                    rc = att.getNodeValue().equals(value);
                }
            } else {
                try {
                    Node _node = XML.getRelativeNode(node, name);
                    rc = node != null && node.getTextContent().equals(value);
                } catch (Exception ex) {
                    rc = false;
                }
            }
        }
        return rc;
    }
}
