package siva;

import java.io.File;
import java.util.ArrayList;
import java.util.Hashtable;
import org.sanskritlibrary.SAXParser;
import org.sanskritlibrary.SAXParserHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class PathCollection implements SAXParserHandler {
    Hashtable<String, LocationInfo> info = new Hashtable<String, LocationInfo>();
    String dirname;
    String currentFilename;
    SAXParser saxParser;
    Locator locator;
    ArrayList<String> path = new ArrayList<String>();

    public PathCollection (String dirname) {
        this.dirname = dirname;
        saxParser = new SAXParser(this);
        File[] files = new File(dirname).listFiles();
        for (File file : files) {
            if (file.getName().endsWith(".xml")) {
                try {
                    parse(file.getAbsolutePath());
                } catch (Exception ex) {
                    System.out.println(ex.getMessage());
                }
            }
        }
    }

    Hashtable<String, LocationInfo> getInfo () {
        return info;
    }

    public void parse(String filename) throws Exception {
        try {
            currentFilename = filename;
            saxParser.parse(filename);
        } catch (Exception ex) {

        }
    }

    public void warning(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void error(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        System.out.format("%s:%d.%d %s\n", currentFilename, locator.getLineNumber(), locator.getColumnNumber(), exception.getMessage());
        throw new SAXException("Boom!");
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public void startDocument() throws SAXException {
    }

    public void endDocument() throws SAXException {
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException {
    }

    public void endPrefixMapping(String prefix) throws SAXException {
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
        path.add(qName);
        String key = stringifyPath();
        if (info.get(key) == null) {
            info.put(key, new LocationInfo(currentFilename, locator.getLineNumber(), locator.getColumnNumber()));
        } else {
            info.get(key).count++;
        }
    }

    private String stringifyPath () {
        StringBuilder sb = new StringBuilder();
        String delim = "";
        for (String s : path) {
            sb.append(String.format("%s%s", delim, s));
            delim = ".";
        }

        return sb.toString();
    }

    public void endElement(String uri, String localName, String qName) throws SAXException {
        path.remove(path.size()-1);
    }

    public void characters(char[] ch, int start, int length) throws SAXException {
    }

    private String fixup (String s) {
        return s;                           // write this if necessary
    }

}
